;REFRESH...Sets the memory refresh rate on an IBM PC/XT, PC/AT or 100 percent
;	   compatible.	The number can be 0 to 65535, if no number is specified,
;	   then a default rate of 25 will be used.
;
;Written by:
;
;  Joseph Albrecht
;  9250 Old Cedar Ave.	#215
;  Bloomington, MN  55425
;

Default		EQU	25

;*******************************************************************************
Code	SEGMENT PARA PUBLIC 'CODE'	;Define code segement

	ASSUME	CS:Code,DS:Code,ES:Code,SS:Code

		ORG	100H		;COM files start at 100H

;-------------------------------------------------------------------------------

Main		PROC	NEAR

;Get memory refresh rate from command line
	MOV	SI,80H		;See if there is anything on command line
	LODSB			; ..
	CBW			; ..
	OR	AX,AX		; ..
	JZ	GetRate3	;No, don't check the command line

;Remove leading blanks
	XCHG	CX,AX		;Command line count in CX
GetRate1:
	LODSB			;Get a character from the command line
	CMP	AL,' '		;Keep looping if it's blank
	LOOPE	GetRate1	; ..
	INC	CX		;Adjust count
	OR	CX,CX		;See if there are any more characters
	JZ	GetRate3	; ..
	CMP	CX,5		;Make sure there is only 5 digits
	JA	GetRate3	; ..

;Now get the number
	DEC	SI		;Point back to 1st character on command line
	XOR	AX,AX		;Initialize accumlator to 0
	XOR	BH,BH		;Clear upper half of BX
	MOV	DI,10		;Initial mutliplier
GetRate2:
	MOV	BL,[SI]		;Get digit
	SUB	BL,'0'		;Check if too low
	JL	GetRate3	; ..
	CMP	BL,9		;Check if too high
	JG	GetRate3	; ..
	MUL	DI		;Multiply previous result
	ADD	AX,BX		;ADD in digit
	INC	SI		;Point to next digit
	LOOP	GetRate2	;Do next digit
	JMP	SetRate		;Set new refresh rate
GetRate3:
	MOV	AX,Default	;Use default refresh rate

;Set new memory refresh rate
SetRate:
	CLI			;Disable interrupts until new rate is set
	PUSH   AX		;Save refresh rate
	MOV    AL,74H		;Set 8253 command mode register
	OUT    43H,AL		; ..
	POP    AX		;Restore refresh rate
	OUT    41H,AL		;Load counter 2 with new memory refresh rate
	MOV    AL,AH		; ..
	OUT    41H,AL		; ..
	STI			;Enable interrupts again

	MOV	AX,4C00H	;Return to DOS
	INT	21H		; ..

Main		ENDP

;-------------------------------------------------------------------------------

Code		ENDS
;*******************************************************************************

	END	Main
